/* (C) 2022 YiRing, Inc. */
package com.yiring.app.web.map;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yiring.app.feign.MapClient;
import com.yiring.app.vo.map.MapVo;
import com.yiring.auth.util.ZyUtil;
import com.yiring.common.core.Result;
import com.yiring.common.core.Status;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import java.util.List;
import javax.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 地图控制器
 *
 * @author Administrator
 * @version 1.0
 * @description:
 * @date 2022/4/24 13:48
 */
@Slf4j
@Validated
@Api(tags = "Map(地图)")
@RestController
@RequestMapping("/map/")
public class MapController {

    @Resource
    MapClient mapClient;

    @GetMapping("/mapSelect")
    @ApiImplicitParams({ @ApiImplicitParam(value = "orgId", required = true, name = "orgId") })
    public Result<MapVo> mapSelect(String orgId) {
        String login = ZyUtil.login();
        JSONObject jsonObject = mapClient.selectMap(orgId, "bearer " + login);
        //        if (ObjectUtil.isNotNull(jsonObject.getJSONArray("data"))) {
        //            List<MapVo.MapVoReuslt> data = jsonObject.getJSONArray("data").toJavaList(MapVo.MapVoReuslt.class);
        //            MapVo mapVo = MapVo.builder().data(data).build();
        //            return Result.ok(mapVo);
        //        } else {
        //            return Result.no(Status.NOT_FOUND);
        //        }
        if (ObjectUtil.isNotNull(jsonObject.get("data"))) {
            ObjectMapper objectMapper = new ObjectMapper();
            List data = objectMapper.convertValue(jsonObject.get("data"), List.class);
            MapVo mapVo = MapVo.builder().data(data).build();
            return Result.ok(mapVo);
        } else {
            return Result.no(Status.NOT_FOUND);
        }
    }
}
